Open In App

Count pairs having bitwise XOR greater than K from a given array

Improve
Improve
Like Article
Like
Save
Share
Report

Given an array arr[]of size N and an integer K, the task is to count the number of pairs from the given array such that the Bitwise XOR of each pair is greater than K

 Examples:

Input: arr = {1, 2, 3, 5} , K = 2 
Output:
Explanation: 
Bitwise XOR of all possible pairs that satisfy the given conditions are: 
arr[0] ^ arr[1] = 1 ^ 2 = 3 
arr[0] ^ arr[3] = 1 ^ 5 = 4 
arr[1] ^ arr[3] = 2 ^ 5 = 7 
arr[0] ^ arr[3] = 3 ^ 5 = 6 
Therefore, the required output is 4. 

Input: arr[] = {3, 5, 6,8}, K = 2 
Output:
 

Naive Approach: The simplest approach to solve this problem is to traverse the given array and generate all possible pairs of the given array and for each pair, check if bitwise XOR of the pair is greater than K or not. If found to be true, then increment the count of pairs having bitwise XOR greater than K. Finally, print the count of such pairs obtained.

C++




// C++ program to implement
// the above approach
 
#include <bits/stdc++.h>
using namespace std;
 
// Function to Count pairs having
// bitwise XOR greater than K
// from a given array
int cntGreaterPairs(int arr[], int n, int k)
{
    // Variable initialise to store the count
    int count=0;
     
    // Traverse in the array and
    // generate all possible pairs
    // of the given array
    for(int i=0;i<n;i++)
    {
        for(int j=i+1;j<n;j++)
        {
            // For every pair, check if bitwise
            // XOR of the pair is greater than
            // K or not
            if(arr[i]^arr[j]>k)
            count++;
        }
    }
     
    // return the count
    return count;
}
 
//Driver code
int main()
{
    int arr[] = {3, 5, 6, 8};
    int K= 2;
    int N = sizeof(arr) / sizeof(arr[0]);
     
    cout<<cntGreaterPairs(arr, N, K);
}
 
// This code is contributed by Utkarsh Kumar.


Java




// Java program to implement
// the above approach
 
import java.util.*;
 
class Main {
 
    // Function to Count pairs having
    // bitwise XOR greater than K
    // from a given array
    static int cntGreaterPairs(int arr[], int n, int k)
    {
        // Variable initialise to store the count
        int count = 0;
 
        // Traverse in the array and
        // generate all possible pairs
        // of the given array
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                // For every pair, check if bitwise
                // XOR of the pair is greater than
                // K or not
                if ((arr[i] ^ arr[j]) > k)
                    count++;
            }
        }
 
        // return the count
        return count;
    }
 
    // Driver code
    public static void main(String args[])
    {
        int arr[] = { 3, 5, 6, 8 };
        int K = 2;
        int N = arr.length;
 
        System.out.print(cntGreaterPairs(arr, N, K));
    }
}


Python3




# Function to count pairs having bitwise XOR greater than K from a given array
def cntGreaterPairs(arr, n, k):
   
    # Variable initialise to store the count
    count = 0
     
    # Traverse in the array and
    # generate all possible pairs
    # of the given array
    for i in range(n):
        for j in range(i+1, n):
           
            # For every pair, check if bitwise
            # XOR of the pair is greater than
            # K or not
            if arr[i]^arr[j] > k:
                count += 1
     
    # Return the count
    return count
 
# Driver code
arr = [3, 5, 6, 8]
K = 2
N = len(arr)
 
print(cntGreaterPairs(arr, N, K))


Javascript




// Function to count pairs having bitwise XOR greater than K from a given array
function cntGreaterPairs(arr, n, k) {
// Variable initialise to store the count
let count = 0;
 
// Traverse in the array and
// generate all possible pairs
// of the given array
for (let i = 0; i < n; i++) {
    for (let j = i+1; j < n; j++) {
       
        // For every pair, check if bitwise
        // XOR of the pair is greater than
        // K or not
        if ((arr[i]^arr[j]) > k) {
            count++;
        }
    }
}
 
// Return the count
return count;
}
 
// Driver code
const arr = [3, 5, 6, 8];
const K = 2;
const N = arr.length;
 
console.log(cntGreaterPairs(arr, N, K));


C#




using System;
 
public class Program
{
    // Function to Count pairs having
    // bitwise XOR greater than K
    // from a given array
    public static int cntGreaterPairs(int[] arr, int n, int k)
    {
        // Variable initialise to store the count
        int count = 0;
 
        // Traverse in the array and
        // generate all possible pairs
        // of the given array
        for (int i = 0; i < n; i++)
        {
            for (int j = i + 1; j < n; j++)
            {
                // For every pair, check if bitwise
                // XOR of the pair is greater than
                // K or not
                if ((arr[i] ^ arr[j]) > k)
                    count++;
            }
        }
 
        // return the count
        return count;
    }
 
    //Driver code
    public static void Main()
    {
        int[] arr = { 3, 5, 6, 8 };
        int K = 2;
        int N = arr.Length;
 
        Console.WriteLine(cntGreaterPairs(arr, N, K));
    }
}


Output

6

Time Complexity:O(N2)
Auxiliary Space:O(1)

Efficient Approach: The problem can be solved using Trie. The idea is to iterate over the given array and for each array element, count the number of elements present in the Trie whose bitwise XOR with the current element is greater than K and insert the binary representation of the current element into the Trie. Finally, print the count of pairs having bitwise XOR greater than K. Follow the steps below to solve the problem:

Below is the implementation of the above approach:

C++




// C++ program to implement
// the above approach
 
#include <bits/stdc++.h>
using namespace std;
 
// Structure of Trie
struct TrieNode
{
    // Stores binary representation
    // of numbers
    TrieNode *child[2];
 
    // Stores count of elements
    // present in a node 
    int cnt;
     
    // Function to initialize
    // a Trie Node
    TrieNode() {
        child[0] = child[1] = NULL;
        cnt = 0;
    }
};
 
 
// Function to insert a number into Trie
void insertTrie(TrieNode *root, int N) {
     
    // Traverse binary representation of X.
    for (int i = 31; i >= 0; i--) {
         
        // Stores ith bit of N
        bool x = (N) & (1 << i);
         
        // Check if an element already
        // present in Trie having ith bit x.
        if(!root->child[x]) {
             
            // Create a new node of Trie.
            root->child[x] = new TrieNode();
        }
         
        // Update count of elements
        // whose ith bit is x
        root->child[x]->cnt+= 1;
         
        // Update root.
        root= root->child[x];
    }
}
 
 
// Function to count elements
// in Trie whose XOR with N
// exceeds K
int cntGreater(TrieNode * root,
                int N, int K)
{
     
    // Stores count of elements
    // whose XOR with N exceeding K
    int cntPairs = 0;
     
    // Traverse binary representation
    // of N and K in Trie
    for (int i = 31; i >= 0 &&
                     root; i--) {
                                    
        // Stores ith bit of N                        
        bool x = N & (1 << i);
         
        // Stores ith bit of K
        bool y = K & (1 << i);
         
        // If the ith bit of K is 1
        if (y) {
             
            // Update root.
            root =
                root->child[1 - x];
        }
         
        // If the ith bit of K is 0
        else{
             
            // If an element already
            // present in Trie having
            // ith bit (1 - x)
            if (root->child[1 - x]) {
                 
                // Update cntPairs
                cntPairs +=
                root->child[1 - x]->cnt;
            }
             
            // Update root.
            root = root->child[x];
        }
    }
    return cntPairs;
}
 
// Function to count pairs that
// satisfy the given conditions.
int cntGreaterPairs(int arr[], int N,
                             int K) {
     
    // Create root node of Trie
    TrieNode *root = new TrieNode();
     
    // Stores count of pairs that
    // satisfy the given conditions
    int cntPairs = 0;
     
    // Traverse the given array.
    for(int i = 0;i < N; i++){
         
        // Update cntPairs
        cntPairs += cntGreater(root,
                           arr[i], K);
         
        // Insert arr[i] into Trie.
        insertTrie(root, arr[i]);
    }
    return cntPairs;
}
 
//Driver code
int main()
{
    int arr[] = {3, 5, 6, 8};
    int K= 2;
    int N = sizeof(arr) / sizeof(arr[0]);
     
    cout<<cntGreaterPairs(arr, N, K);
}


Java




// Java program to implement
// the above approach
import java.util.*;
class GFG{
 
// Structure of Trie
static class TrieNode
{
  // Stores binary representation
  // of numbers
  TrieNode []child = new TrieNode[2];
 
  // Stores count of elements
  // present in a node 
  int cnt;
 
  // Function to initialize
  // a Trie Node
  TrieNode()
  {
    child[0] = child[1] = null;
    cnt = 0;
  }
 
};
 
// Function to insert a number
// into Trie
static void insertTrie(TrieNode root,
                       int N)
{
  // Traverse binary representation
  // of X.
  for (int i = 31; i >= 0; i--)
  {
    // Stores ith bit of N
    int x = (N) & (1 << i);
 
    // Check if an element already
    // present in Trie having ith
    // bit x.
    if (x < 2 && root.child[x] == null)
    {
      // Create a new node of Trie.
      root.child[x] = new TrieNode();
    }
 
    // Update count of elements
    // whose ith bit is x
    if(x < 2 && root.child[x] != null)
      root.child[x].cnt += 1;
 
    // Update root.
    if(x < 2)
      root = root.child[x];
  }
}
 
// Function to count elements
// in Trie whose XOR with N
// exceeds K
static int cntGreater(TrieNode root,
                      int N, int K)
{
  // Stores count of elements
  // whose XOR with N exceeding K
  int cntPairs = 1;
 
  // Traverse binary representation
  // of N and K in Trie
  for (int i = 31; i >= 0 &&
           root!=null; i--)
  {
    // Stores ith bit of N
    int x = N & (1 << i);
 
    // Stores ith bit of K
    int y = K & (1 << i);
 
    // If the ith bit of K is 1
    if (y == 1)
    {
      // Update root.
      root = root.child[1 - x];
    }
 
    // If the ith bit of K is 0
    else
    {
      // If an element already
      // present in Trie having
      // ith bit (1 - x)
      if (x < 2 &&
          root.child[1 - x] != null)
      {
        // Update cntPairs
        cntPairs += root.child[1 - x].cnt;
      }
 
      // Update root.
      if(x < 2)
        root = root.child[x];
    }
  }
  return cntPairs;
}
 
// Function to count pairs that
// satisfy the given conditions.
static int cntGreaterPairs(int arr[],
                           int N, int K)
{
  // Create root node of Trie
  TrieNode root = new TrieNode();
 
  // Stores count of pairs that
  // satisfy the given conditions
  int cntPairs = 0;
 
  // Traverse the given array.
  for (int i = 0; i < N; i++)
  {
    // Update cntPairs
    cntPairs += cntGreater(root,
                           arr[i], K);
 
    // Insert arr[i] into Trie.
    insertTrie(root, arr[i]);
  }
  return cntPairs;
}
 
// Driver code
public static void main(String[] args)
{
  int arr[] = {3, 5, 6, 8};
  int K = 2;
  int N = arr.length;
  System.out.print(cntGreaterPairs(arr,
                                   N, K));
}
}
 
// This code is contributed by shikhasingrajput


Python3




# Python3 program to implement
# the above approach
  
# Structure of Trie
class TrieNode:
 
    # Function to initialize
    # a Trie Node
    def __init__(self):
         
        self.child = [None, None]
        self.cnt = 0
 
# Function to insert a number into Trie
def insertTrie(root, N):
     
    # Traverse binary representation of X.
    for i in range(31, -1, -1):
         
        # Stores ith bit of N
        x = bool((N) & (1 << i))
          
        # Check if an element already
        # present in Trie having ith bit x.
        if (root.child[x] == None):
              
            # Create a new node of Trie.
            root.child[x] = TrieNode()
             
        # Update count of elements
        # whose ith bit is x
        root.child[x].cnt += 1
          
        # Update root
        root= root.child[x]
  
# Function to count elements
# in Trie whose XOR with N
# exceeds K
def cntGreater(root, N, K):
      
    # Stores count of elements
    # whose XOR with N exceeding K
    cntPairs = 0
      
    # Traverse binary representation
    # of N and K in Trie
    for i in range(31, -1, -1):
        if (root == None):
            break
                                     
        # Stores ith bit of N                        
        x = bool(N & (1 << i))
          
        # Stores ith bit of K
        y = K & (1 << i)
          
        # If the ith bit of K is 1
        if (y != 0):
              
            # Update root
            root = root.child[1 - x]
          
        # If the ith bit of K is 0
        else:
             
            # If an element already
            # present in Trie having
            # ith bit (1 - x)
            if (root.child[1 - x]):
                  
                # Update cntPairs
                cntPairs += root.child[1 - x].cnt
              
            # Update root
            root = root.child[x]
 
    return cntPairs
 
# Function to count pairs that
# satisfy the given conditions.
def cntGreaterPairs(arr, N, K):
      
    # Create root node of Trie
    root = TrieNode()
      
    # Stores count of pairs that
    # satisfy the given conditions
    cntPairs = 0
      
    # Traverse the given array.
    for i in range(N):
          
        # Update cntPairs
        cntPairs += cntGreater(root, arr[i], K)
          
        # Insert arr[i] into Trie.
        insertTrie(root, arr[i])
     
    return cntPairs
 
# Driver code
if __name__=='__main__':
     
    arr = [ 3, 5, 6, 8 ]
    K = 2
    N = len(arr)
      
    print(cntGreaterPairs(arr, N, K))
     
# This code is contributed by rutvik_56


C#




// C# program to implement
// the above approach
using System;
 
class GFG{
 
// Structure of Trie
public class TrieNode
{
 
  // Stores binary representation
  // of numbers
  public TrieNode []child = new TrieNode[2];
   
  // Stores count of elements
  // present in a node 
  public int cnt;
   
  // Function to initialize
  // a Trie Node
  public TrieNode()
  {
    child[0] = child[1] = null;
    cnt = 0;
  }
};
 
// Function to insert a number
// into Trie
static void insertTrie(TrieNode root,
                       int N)
{
   
  // Traverse binary representation
  // of X.
  for(int i = 31; i >= 0; i--)
  {
     
    // Stores ith bit of N
    int x = (N) & (1 << i);
 
    // Check if an element already
    // present in Trie having ith
    // bit x.
    if (x < 2 && root.child[x] == null)
    {
       
      // Create a new node of Trie.
      root.child[x] = new TrieNode();
    }
 
    // Update count of elements
    // whose ith bit is x
    if(x < 2 && root.child[x] != null)
      root.child[x].cnt += 1;
 
    // Update root.
    if(x < 2)
      root = root.child[x];
  }
}
 
// Function to count elements
// in Trie whose XOR with N
// exceeds K
static int cntGreater(TrieNode root,
                      int N, int K)
{
   
  // Stores count of elements
  // whose XOR with N exceeding K
  int cntPairs = 1;
 
  // Traverse binary representation
  // of N and K in Trie
  for(int i = 31; i >= 0 &&
      root != null; i--)
  {
     
    // Stores ith bit of N
    int x = N & (1 << i);
 
    // Stores ith bit of K
    int y = K & (1 << i);
 
    // If the ith bit of K is 1
    if (y == 1)
    {
       
      // Update root.
      root = root.child[1 - x];
    }
 
    // If the ith bit of K is 0
    else
    {
       
      // If an element already
      // present in Trie having
      // ith bit (1 - x)
      if (x < 2 &&
          root.child[1 - x] != null)
      {
         
        // Update cntPairs
        cntPairs += root.child[1 - x].cnt;
      }
 
      // Update root.
      if(x < 2)
        root = root.child[x];
    }
  }
  return cntPairs;
}
 
// Function to count pairs that
// satisfy the given conditions.
static int cntGreaterPairs(int []arr,
                           int N, int K)
{
   
  // Create root node of Trie
  TrieNode root = new TrieNode();
 
  // Stores count of pairs that
  // satisfy the given conditions
  int cntPairs = 0;
 
  // Traverse the given array.
  for(int i = 0; i < N; i++)
  {
     
    // Update cntPairs
    cntPairs += cntGreater(root,
                           arr[i], K);
 
    // Insert arr[i] into Trie.
    insertTrie(root, arr[i]);
  }
  return cntPairs;
}
 
// Driver code
public static void Main(String[] args)
{
  int []arr = { 3, 5, 6, 8 };
  int K = 2;
  int N = arr.Length;
   
  Console.Write(cntGreaterPairs(arr,
                                N, K));
}
}
 
// This code is contributed by gauravrajput1


Javascript




<script>
// Javascript program to implement
// the above approach
 
// Structure of Trie
class TrieNode
{
    constructor()
    {
        this.child = new Array(2);
        this.child[0] = this.child[1] = null;
        this.cnt = 0;
    }
}
 
// Function to insert a number
// into Trie
function insertTrie(root,N)
{
 
    // Traverse binary representation
  // of X.
  for (let i = 31; i >= 0; i--)
  {
   
    // Stores ith bit of N
    let x = (N) & (1 << i);
  
    // Check if an element already
    // present in Trie having ith
    // bit x.
    if (x < 2 && root.child[x] == null)
    {
      // Create a new node of Trie.
      root.child[x] = new TrieNode();
    }
  
    // Update count of elements
    // whose ith bit is x
    if(x < 2 && root.child[x] != null)
      root.child[x].cnt += 1;
  
    // Update root.
    if(x < 2)
      root = root.child[x];
  }
}
 
// Function to count elements
// in Trie whose XOR with N
// exceeds K
function  cntGreater(root, N, K)
{
 
    // Stores count of elements
  // whose XOR with N exceeding K
  let cntPairs = 1;
  
  // Traverse binary representation
  // of N and K in Trie
  for (let i = 31; i >= 0 &&
           root!=null; i--)
  {
    // Stores ith bit of N
    let x = N & (1 << i);
  
    // Stores ith bit of K
    let y = K & (1 << i);
  
    // If the ith bit of K is 1
    if (y == 1)
    {
     
      // Update root.
      root = root.child[1 - x];
    }
  
    // If the ith bit of K is 0
    else
    {
     
      // If an element already
      // present in Trie having
      // ith bit (1 - x)
      if (x < 2 &&
          root.child[1 - x] != null)
      {
        // Update cntPairs
        cntPairs += root.child[1 - x].cnt;
      }
  
      // Update root.
      if(x < 2)
        root = root.child[x];
    }
  }
  return cntPairs;
}
 
// Function to count pairs that
// satisfy the given conditions.
function cntGreaterPairs(arr,N,K)
{
    // Create root node of Trie
  let root = new TrieNode();
  
  // Stores count of pairs that
  // satisfy the given conditions
  let cntPairs = 0;
  
  // Traverse the given array.
  for (let i = 0; i < N; i++)
  {
    // Update cntPairs
    cntPairs += cntGreater(root,
                           arr[i], K);
  
    // Insert arr[i] into Trie.
    insertTrie(root, arr[i]);
  }
  return cntPairs;
}
 
// Driver code
let arr=[3, 5, 6, 8];
let K = 2;
let N = arr.length;
document.write(cntGreaterPairs(arr,N, K));
     
 
// This code is contributed by patel2127
</script>


Output

6

Time Complexity:O(N * 32)
Auxiliary Space:O(N * 32)



Last Updated : 22 Mar, 2023
Like Article
Save Article
Previous
Next
Share your thoughts in the comments
Similar Reads